#include "box.h"
#include "mainwindow.h"

int Box::newSelected=-1;
int Box::oldSelected=-1;
QFont Box::little=QFont("Courier", 8);
QFont Box::big=QFont("Courier", 32);

Box::Box(int size, int id, int value, QMainWindow *w, QWidget *parent) :
        QTextEdit(parent),
        size(size),
        id(id),
        w(w)
{
    setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    setFixedSize(50,50);

    QObject::connect(this, SIGNAL(  selectionChanged()),
                     this, SLOT(    focus()));

    QObject::connect(this, SIGNAL(  textChanged()),
                     this, SLOT(    change()));

    setPlainText("-");  //cant be initialized to empty value or space (no "", no " ")
    unfocus(value);

    /*
    switch(size)
    {
    case 2:
        insertPlainText("1 2\n3 4");
        setFixedSize(36,36);
        break;

    case 3:
        insertPlainText("1 2 3\n4 5 6\n7 8 9");
        setFixedSize(50,50);
        break;

    case 4:
        insertPlainText(" 1  2  3  4\n 5  6  7  8\n 9 10 11 12\n13 14 15 16");
        setFixedSize(90,90);
        break;

    case 5:
        insertPlainText(" 1  2  3  4  5\n 6  7  8  9 10\n11 12 13 14 15\n16 17 18 19 20\n21 22 23 24 25");
        setFixedSize(110,110);
        break;

    default:
        qDebug() <<"dimensione del Box non valida: " <<size;
        exit(1);
    }
    */

}

void Box::refresh(int value)
{
    //restore old value
    if(value & ((MainWindow *) w)->mask)
    {
        if(((MainWindow *) w)->showPossibilities)
        {
            setCurrentFont(little);

            QString s;
            value & 1<<1? s+="1" : s+=" ";
            value & 1<<2? s+=" 2" : s+="  ";
            value & 1<<3? s+=" 3\n" : s+="  \n";
            value & 1<<4? s+="4" : s+=" ";
            value & 1<<5? s+=" 5" : s+="  ";
            value & 1<<6? s+=" 6\n" : s+="  \n";
            value & 1<<7? s+="7" : s+=" ";
            value & 1<<8? s+=" 8" : s+="  ";
            value & 1<<9? s+=" 9" : s+="  ";
            setPlainText(s);
            setReadOnly(true);
        }else{
            setPlainText("");
            setReadOnly(false);
        }

    }else{
        setCurrentFont(big);
        setPlainText(QString::number(value).toAscii());
        setReadOnly(false);
    }
}



void Box::unfocus(int value)
{
    int newValue=toPlainText().toInt();

    if(newValue>=1 &&
       newValue<=((MainWindow *) w)->n2)
    {
        //show new value
        ((MainWindow *) w)->setValue(id, newValue);
        //setCurrentFont(big);
        //setPlainText(QString::number(newValue).toAscii());


    }else{
        /*
        setCurrentFont(little);
        setPlainText("1 2 3\n4 5 6\n7 8 9");
        */

        if(toPlainText().trimmed()=="")
        {
            //reset value
            ((MainWindow *) w)->setValue(id, -1);
        }else{

            //restore old value
            if(value & ((MainWindow *) w)->mask)
            {
                if(((MainWindow *) w)->showPossibilities)
                {
                    setCurrentFont(little);

                    QString s;
                    value & 1<<1? s+="1" : s+=" ";
                    value & 1<<2? s+=" 2" : s+="  ";
                    value & 1<<3? s+=" 3\n" : s+="  \n";
                    value & 1<<4? s+="4" : s+=" ";
                    value & 1<<5? s+=" 5" : s+="  ";
                    value & 1<<6? s+=" 6\n" : s+="  \n";
                    value & 1<<7? s+="7" : s+=" ";
                    value & 1<<8? s+=" 8" : s+="  ";
                    value & 1<<9? s+=" 9" : s+="  ";
                    setPlainText(s);
                    setReadOnly(true);
                }

            }else{
                setCurrentFont(big);
                setPlainText(QString::number(value).toAscii());
                setReadOnly(false);
            }
        }
    }
}

void Box::focus()
{
    oldSelected=newSelected;
    newSelected=id;

    if(oldSelected!=newSelected)
    {
        if(oldSelected!=-1)
            ((MainWindow *) w)->unfocusBox(oldSelected);    //cambia la vecchia cell

        if(currentFont()!=big)
        {
            setCurrentFont(big);
            setPlainText("");
        }

        setReadOnly(false);
    }
}

void Box::change()
{
    if(toPlainText().length()==2)
        setPlainText(toPlainText().at(0));
}
